#ifndef BPMPLOT_H
#define BPMPLOT_H

#include <cucontrolsfactorypool.h>
#include <quspectrumplot.h>

class QuTimeArray3DPlotPlugin_I;

class BpmPlot : public QObject
{
    Q_OBJECT
public:
    BpmPlot(QWidget *parent, CumbiaPool *cp, const CuControlsFactoryPool& fp, QuTimeArray3DPlotPlugin_I *ta3dp);
    QWidget *widget();
    void setSource(const QString& s);
    void setHistorySiz(int n);

protected slots:
    void onUpdate(const CuData& da);
    void setAutoscale(bool a);
    void on3DConfClicked();

private:
    QWidget *m_plot;
    QWindow *m_surface;
    QWidget *m_container;
    QuTimeArray3DPlotPlugin_I *m_ta3dp;
    CumbiaPool *m_cu_p;
    const CuControlsFactoryPool m_fpool;
    QMap<int, QuPlotCurve *> m_crvmap;
    QMap<int, QColor> m_colormap;
    int m_history_siz;

    void m_fill_colormap();
};

#endif // BPMPLOT_H
